/*
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.xsdc.java;

class JavaComplexType implements JavaType {
    final private String name;

    JavaComplexType(String name) {
        this.name = name;
    }

    @Override
    public boolean isPrimitiveType() {
        return false;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String getNullableName() {
        return name;
    }

    @Override
    public String getParsingExpression() {
        return String.format("%s value = %s.read(parser);\n", name, name);
    }

    @Override
    public String getWritingExpression(String getValue, String name) {
        return String.format("%s.write(out, \"%s\");\n", getValue, name);
    }
}
